/******************************************************************************
 SCI Template Game
 By Brian Provinciano
 ******************************************************************************
 rm001.sc
 Contains the first room of your game. 
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 1)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(use "jump")
(use "dpath")
(use "follow")
(local v
	   
	   maxViewDefined = 245  // last view number available to display

	   stateFlag
	   positioning
	   
	   
	   /*  Min/Max placement of views - start */
	   groundViewXMin = 0
	   groundViewXMax = 320
	   groundViewYMin = 80
	   groundViewYMax = 189
	   
	   skyViewXMin = 0
	   skyViewXMax = 320
	   skyViewYMin = 0
	   skyViewYMax = 40 
	   
       // populate the following 4 based on what the view classification is
	   viewClassXMin
	   viewClassXMax
	   viewClassYMin
	   viewClassYMax
	   /*  Min/Max placement of views - end */
	   
	   priority
	   view
	   i
	  
	   xSize
	   ySize
	   xHot
	   yHot
	   
	   celWidthView
	   celWidthBase
	   xBase
	   xPos
       yPos
	   hotspotDelta
	   

	   // remaining counts left for each view type for this iteration
	   GC_rem
	   SF_rem
	   CV_rem
	   SK_rem
	   IP_rem
	   TR_rem
	   BU_rem
	   ST_rem
	   RK_rem
	   BD_rem
	   

       // view properties used to ouptut script files
       viewCount
       vw[50]       // array for storing all views
       scriptNum[4]

//                    0                   5                  10                  15                  20                  25                  30 
  xBounded [1000] = (-1   U   R   U   R   U   L   L   U   U   U   R   U   L   U   L   R   L   U   U   U   U   U   U   U   U   U   U   L   U   X   // 30
  	                      L   U   U   U   R   U   U   U   U   U   U   L   X   U   L   R   L   U   L   U   U   U   X   X   X   L   U   U   U   R   // 60
  	                      U   U   X   R   U   R   L   R   U   U   U   U   L   U   U   R   U   U   U   L   U   U   U   U   U   R   L   U   U   U   // 90
  	                      U   U   U   U   U   U   U   U   L   R   U   U   U   U   U   U   U   U   R   L   U   U   U   U   U   U   L   R   U   U   // 120
                          L   U   R   R   L   L   U   U   R   L   L   U   R   U   U   U   U   U   U   L   R   L   U   U   U   U   U   U   U   U   // 150
                          L   U   U   L   R   L   U   U   U   R   U   X   X   U   U   U   U   U   U   U   U   U   U   R   L   L   R   U   U   U   // 180
                          U   U   U   U   U   U   U   U   U   U   R   U   X   L   R   R   U   L   U   L   R   X   L   R   L   U   R   X   L   R   // 210
                          U   U   R   L   R   U   U   L   R   U   R   L   R   U   R   L   L   X   U   U   U   U   U   L   U   U   U   U   U   U   // 240
                          L   U   X   R   U
       	        )
       	        
// yBounded:  U:unclassified G:ground cover F:'shadow' foreground C:cave S:sky
//       	          0                   5                  10                  15                  20                  25                  30 
  yBounded [1000] = (-1   U   T   U   T   U   T   T   U   U   U   U   U   T   B   B   T   T   U   U   U   U   U   U   U   U   U   U   T   T   X   // 30
  	                      B   U   U   U   T   U   U   U   U   U   U   T   X   T   T   T   U   U   U   U   U   U   X   X   X   T   U   B   U   T   // 60
  	                      U   U   X   T   U   U   T   B   U   T   U   U   T   U   U   T   U   U   U   T   U   U   B   U   U   T   T   T   U   U   // 90
  	                      U   U   U   U   U   U   U   U   U   B   U   U   U   U   T   U   U   U   T   T   U   U   U   U   U   U   T   B   U   U   // 120
                          T   U   U   T   U   B   U   T   U   U   U   U   U   U   T   T   U   U   U   B   U   U   U   U   U   U   U   U   U   U   // 150
                          U   U   U   U   B   U   U   B   U   T   B   X   X   U   U   U   U   U   U   U   U   T   U   B   T   B   T   B   U   U   // 180
                          U   T   U   U   U   T   U   U   U   B   B   T   X   T   T   B   T   B   B   B   B   X   U   B   U   U   U   X   U   U   // 210
                          U   U   U   T   T   B   B   T   B   U   T   T   T   T   B   B   T   X   U   U   U   U   U   U   U   U   U   U   T   U   // 240
                          U   U   X   U   U
       	        )

  // rtypes:  UC:unclassified GC:ground cover SF:'shadow' foreground CV:cave SK:sky I:inside T:Tree B:Bush R:Rock
	   //         0                   5                  10                  15                  20                  25                  30
  rType[1000] = (-1  BU  TR  ST  TR  ST  TR  SF  BU  BU  BU  BU  BU  TR  BU  BU  SF  TR  BU  RK  RK  BU  TR  BU  BU  BU  BU  TR  SF  TR  TR   // 30
                     RK  BU  BU  RK  SF  RK  BU  BU  BU  BU  BU  TR  XX  TR  SF  SF  GC  BU  BU  RK  BU  BU  XX  XX  XX  TR  BU  BU  BU  TR   // 60
                     RK  BU  XX  SF  BU  GC  SF  SF  BU  TR  RK  RK  TR  BU  TR  TR  BU  TR  TR  TR  BU  RK  RK  BU  RK  TR  TR  TR  RK  RK   // 90
                     BU  BU  RK  BU  BU  RK  RK  BU  BU  BU  RK  TR  TR  BU  TR  TR  BU  RK  TR  TR  GC  GC  GC  GC  BU  TR  TR  GC  RK  RK   // 120
                     TR  BU  BU  TR  BU  BU  TR  TR  RK  BU  RK  RK  BU  BU  TR  TR  ST  ST  TR  BU  BD  BD  ST  ST  BU  RK  RK  RK  BU  BU   // 150
                     BU  ST  BU  GC  RK  BU  BU  XX  CV  CV  CV  CV  CV  SK  SK  SK  SK  SK  SK  SK  SK  SK  SK  TR  TR  TR  TR  RK  RK  RK   // 180
                     SK  TR  SK  SK  SK  TR  SK  SK  SK  CV  CV  CV  CV  CV  CV  CV  CV  CV  CV  CV  CV  CV  BU  BU  SK  SK  SK  SK  SK  SK   // 210
                     SK  SK  SK  CV  CV  CV  CV  CV  CV  IP  CV  CV  CV  CV  CV  CV  CV  CV  IP  IP  IP  IP  IP  SK  SK  SK  SK  SK  SK  SK   // 240
                     SK  SK  SK  SK  TR
  
                )  
       //         0                   5                  10                  15                  20                  25                  30
 rColor[1000] = ( 0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 30
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 60
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 90
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 120
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 150
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 180
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 210
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 240
                      0   0   0   0   0
                ) 
       //         0                   5                  10                  15                  20                  25                  30
 maxNum[1000] = ( 0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 30
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 60
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 90
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 120
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 150
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 180
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 210
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 240
                      0   0   0   0   0
                ) 

xHotOff[1000] = ( 0   0  30   0   6   0 -31 -66   0   0   0   0   0 -34   0   0   0 -19   0   0   0   0   0   0   0   0   0   0 -28  16   0   // 30
                      0   0   0   0  53   0   0   0   0   0   0 -20   0   6   0   0   0   0   0   0   0   0   0   0   0 -13   0   0   0  31   // 60
                      0   0   0   0   0   0   0   0   0   0   0   0 -25   0   0  45   0   0   0 -12   0   0   0   0   0  20   0 -10   0   0   // 90
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 120
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 150
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 180
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 210
                      0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   // 240
                      0   0   0   0   0
                )  	
)
/******************************************************************************/
(instance public rm001 of Rm
	(properties
		//picture scriptNumber
		// Set up the rooms to go to/come from here
		north 2
		east 2
		south 2
		west 2
	)
	(method (init)
		(var GC_min[3], GC_max[3],
	      	 SF_min[3], SF_max[3],
	      	 CV_min[3], CV_max[3],
	      	 SK_min[3], SK_max[3],
	      	 IP_min[3], IP_max[3],
	      	 TR_min[3], TR_max[3],
	      	 BU_min[3], BU_max[3],
	      	 ST_min[3], ST_max[3],
	      	 RK_min[3], RK_max[3],
	      	 BD_min[3], BD_max[3]
		)
		
		// FIXME, the room defaults to the pic defined for the script # (briefly)
		(send gRoom:picture(1))   // outside
  		//(send gRoom:picture(2))   // cave
  				
  				
		// same in every script, starts things up
  		(super:init())
  		(self:setScript(RoomScript))
		
		// Set up the ego
		//SetUpEgo()		
		//(send gEgo:init())


		(testView:view(0) hide()) // dummy view, used to determine properties of view	

	
		(if(== gInputsCollected 0)


            // init default values
 		    StrCpy(@GC_min "0")		
            StrCpy(@GC_max "3")
 		    StrCpy(@SF_min "0")		
            StrCpy(@SF_max "3")
 		    StrCpy(@CV_min "0")		
            StrCpy(@CV_max "0")
            StrCpy(@SK_min "0")		
            StrCpy(@SK_max "5")
            StrCpy(@IP_min "0")		
            StrCpy(@IP_max "0")
            StrCpy(@TR_min "3")		
            StrCpy(@TR_max "7")
            StrCpy(@BU_min "0")		
            StrCpy(@BU_max "5")
            StrCpy(@ST_min "0")		
            StrCpy(@ST_max "2")
            StrCpy(@RK_min "2")		
            StrCpy(@RK_max "5")
            StrCpy(@BD_min "0")		
            StrCpy(@BD_max "0")
              
            PrintMultiEdit("View Options:\n                                          Min   Max  \nGround Cover:\nShadow Foreground:\nCave:\nClouds:\nInside Props:\nTrees:\nBushes & Flowers:\nStumps & Logs:\nRocks:\nBuildings:\n"
                                  // inputbox size, left margin, column placement, font height, column count
						    #edit @GC_min  3 100 1 12 2
						    #edit @GC_max  3 100 2 
						    #edit @SF_min  3 100 1 
						    #edit @SF_max  3 100 2 
						    #edit @CV_min  3 100 1 
						    #edit @CV_max  3 100 2 
						    #edit @SK_min  3 100 1  
						    #edit @SK_max  3 100 2
						    #edit @IP_min  3 100 1 
						    #edit @IP_max  3 100 2 
						    #edit @TR_min  3 100 1 
						    #edit @TR_max  3 100 2 
						    #edit @BU_min  3 100 1 
						    #edit @BU_max  3 100 2 
						    #edit @ST_min  3 100 1 
						    #edit @ST_max  3 100 2 
						    #edit @RK_min  3 100 1  
						    #edit @RK_max  3 100 2
						    #edit @BD_min  3 100 1 
						    #edit @BD_max  3 100 2 

						    #button "  OK  " 0
						   )
						   
		    // init the counts
	        = GC_cnt Random(ReadNumber(@GC_min) ReadNumber(@GC_max)) 
	        = SF_cnt Random(ReadNumber(@SF_min) ReadNumber(@SF_max)) 
	        = CV_cnt Random(ReadNumber(@CV_min) ReadNumber(@CV_max)) 
	        = SK_cnt Random(ReadNumber(@SK_min) ReadNumber(@SK_max)) 
	        = IP_cnt Random(ReadNumber(@IP_min) ReadNumber(@IP_max)) 
	        = TR_cnt Random(ReadNumber(@TR_min) ReadNumber(@TR_max)) 
	        = BU_cnt Random(ReadNumber(@BU_min) ReadNumber(@BU_max)) 
	        = ST_cnt Random(ReadNumber(@ST_min) ReadNumber(@ST_max)) 
	        = RK_cnt Random(ReadNumber(@RK_min) ReadNumber(@RK_max)) 
	        = BD_cnt Random(ReadNumber(@BD_min) ReadNumber(@BD_max)) 		
					  
	        = gInputsCollected 1
		)
  
	    = viewCount 0	
        
	    // view counts remaining to render
		= GC_rem GC_cnt
		= SF_rem SF_cnt
		= CV_rem CV_cnt
		= SK_rem SK_cnt
		= IP_rem IP_cnt
		= TR_rem TR_cnt
		= BU_rem BU_cnt
		= ST_rem ST_cnt
		= RK_rem RK_cnt
		= BD_rem BD_cnt	        	
	      
	        	 
  
  )
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	/* Cannot get to the nsTop properties until view is fully init-ed? */
	(method (changeState newState)
	    = state newState
	    (switch (state)
	        (case 0
	        	= gSpeed 1    // max the speed so we don't have to wait as long for views to draw
	           	= stateFlag 1
			)	
			(case 1   	// init the view here to allow for the ns values to update before we check them	
                = v PickView()
				(testView:view(v) x(-100) y(-100) init() hide)  // setup the test view so we can grab the ns attributes
                = stateFlag 2      			  				
			)
			(case 2

				    = xSize (- (testView:nsRight) (testView:nsLeft))
				 	= ySize (- (testView:nsBottom) (testView:nsTop)) 
				 	= xHot (- (testView:nsRight) (testView:x))
				 	= yHot (- (testView:nsBottom) (testView:y))					
					
	                (switch (rType[v])
					   (case SK   // sky
						   = viewClassXMin skyViewXMin
						   = viewClassXMax skyViewXMax
						   = viewClassYMin skyViewYMin
						   = viewClassYMax skyViewYMax  
					   )
	                   (default    //  use ground coordinates
						   = viewClassXMin groundViewXMin
						   = viewClassXMax groundViewXMax
						   = viewClassYMin groundViewYMin
						   = viewClassYMax groundViewYMax
					   )    
			        )


					// fixme: needs to allow for view to be 50% offscreen??
					(switch (xBounded[v])
						(case U  // unbounded
						   = xPos Random(viewClassXMin viewClassXMax)	
						)
						(case L  // left bounded
						   = xPos Random(viewClassXMin xHot)   // min is xHot, center of view allowing for 1/2 view to be offscreen	
						)
						(case R  // right bounded 
						   = xPos Random( (- viewClassXMax xHot) viewClassXMax)
						)
		         	)
		         	
		         	// fixme: needs to allow for view to be 50% offscreen??
		         	(switch (yBounded[v])
						(case U  // unbounded
						   // fixme: needs to allow for view to be 50% offscreen??
						   = yPos Random(viewClassYMin viewClassYMax)	
						)
						(case T  // top bounded
						   = yPos Random(viewClassYMin (- ySize 1))	
						)
						(case B  // bottom bounded
						   = yPos Random(viewClassYMax viewClassYMax)
						) 
					)
					
					
					// create the view onscreen
			   	    = vw[viewCount] (View:new())

				   (switch (rType[v])
				   	  (case GC    // ground cover
				   	     (send vw[viewCount]:view(v) x(xPos) y(yPos) cel(0) ignoreActors(1) setPri(0) init()) //addToPic())
					  )
					  
					  (case SF    // 'shadow' foreground
					  	 (send vw[viewCount]:view(v) x(xPos) y(yPos) cel(0) ignoreActors(1) setPri(15) init()) //addToPic())
					  )
					  (default
					  	 // Cel 1 is for the base of the view, if it's not defined, just add cel 0
					  	 (if (== (viewBase:lastCel()) 0)
				            (send vw[viewCount]:view(v) x(xPos) y(yPos) cel(0) ignoreActors(0) init()) //addToPic()) 
					     )(else
					     	
					  	    (send vw[viewCount]:view(v) x(+ xPos xHotOff[v]) y(yPos) ignoreActors(0) init()) //addToPic()) 
					  	    
					  	    (send vw[viewCount]:view(v) x(xPos) y(yPos) cel(0) ignoreActors(1) init()) //addToPic())
						 )  
					  ) 
				    )
           

	                // while there are still views to create, loop
			        (if (   > GC_rem 0 
			             or > SF_rem 0
			             or > SK_rem 0
			             or > IP_rem 0
			             or > TR_rem 0
			             or > BU_rem 0
			             or > ST_rem 0
			             or > RK_rem 0
			             or > BD_rem 0)
			         
			            ++viewCount
			       	    = stateFlag 1
			    	)(else
				     	= gSpeed 9    // view drawing complete, set speed back to a more resonable value
				        = stateFlag 3	
				    )
			)
			(case 3
                // make sure i is valid
               (if (< i 0)
               	  = i viewCount
			   )
			   
			   (if (> i viewCount)
			   	  = i 0
			   )
			   = priority (send vw[i]:priority)
			   = view (send vw[i]:view)
			   
				(cursor1:init() setCycle(Fwd) loop(-1) x((send vw[i]:nsLeft)) y((send vw[i]:nsTop)))
				(cursor2:init() setCycle(Fwd) loop(-1) x((send vw[i]:nsRight)) y((send vw[i]:nsTop)))
				(cursor3:init() setCycle(Fwd) loop(-1) x((send vw[i]:nsLeft)) y((send vw[i]:nsBottom)))
		        (cursor4:init() setCycle(Fwd) loop(-1) x((send vw[i]:nsRight)) y((send vw[i]:nsBottom)))
		        
				(cursor5:init() setCycle(Fwd) loop(-1) x(+ (/ (- (send vw[i]:nsRight) (send vw[i]:nsLeft)) 2) (send vw[i]:nsLeft)) y((send vw[i]:nsTop)))
				(cursor6:init() setCycle(Fwd) loop(-1) x(+ (/ (- (send vw[i]:nsRight) (send vw[i]:nsLeft)) 2) (send vw[i]:nsLeft)) y((send vw[i]:nsBottom)))
				(cursor7:init() setCycle(Fwd) loop(-1) x((send vw[i]:nsLeft))  y(+ (/ (- (send vw[i]:nsBottom)  (send vw[i]:nsTop))  2) (send vw[i]:nsTop)))
				(cursor8:init() setCycle(Fwd) loop(-1) x((send vw[i]:nsRight))  y(+ (/ (- (send vw[i]:nsBottom)  (send vw[i]:nsTop))  2) (send vw[i]:nsTop)))

		     	= stateFlag 4
			)			
			
		)
	)
	
	(method (doit)
        (super:doit)
        (RoomScript:changeState(stateFlag))
	)
    	
	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))





 		(if (== evKEYBOARD (send pEvent:type))
	          (switch (send pEvent:message)
	             (case KEY_RIGHT  ++i)
	             (case KEY_6      ++i)
	             (case KEY_LEFT   --i)
	             (case KEY_4      --i)
	             
	             (case KEY_p   // rotate priority (increment)
				  	  ++priority
				  	  (if (> priority 15)
				  	     = priority 0
			   	      )
				  	  (send vw[i]: setPri(priority) forceUpd())	
				 )  
	             (case KEY_P   // rotate priority (decrement)
				  	  --priority
				  	  (if (< priority 0)
				  	     = priority 15
			   	      )
				  	  (send vw[i]: setPri(priority) forceUpd())	
				 )  
				 
				 (case KEY_v  // rotate view (increment)
				 	  ++view
				 	  (if (> view maxViewDefined)
				 	  	 = view 1
					  )
					  (send vw[i]: view(view) forceUpd())
				 )
				 (case KEY_V  // rotate view (increment)
				 	  --view
				 	  (if (< view 0)
				 	  	 = view maxViewDefined
					  )
					  (send vw[i]: view(view) forceUpd())
				 )	
				 
				 (case KEY_s // save
                     savePrompt()
				 )
				 			 	             
	          )// ends switch	
	          = stateFlag 3
	      )// ends keyboard	

	      (if (== evJOYSTICK (send pEvent:type))
	          (switch (send pEvent:message)
	             (case RIGHT ++i)
	             (case LEFT  --i)
	          )// ends switch
	           = stateFlag 3
	      )// ends joystick	

          (if (== evMOUSEBUTTON (send pEvent:type))
          	  // start view following cursor
          	  (send vw[i]: x((send pEvent:x)) y((send pEvent:y)) forceUpd())
          	  = stateFlag 3
		  )

 	)
)
/******************************************************************************/
(instance viewBase of Prop)
(instance testView of Prop (properties y 100 x 100))

(instance cursor1 of Prop (properties view 0))
(instance cursor2 of Prop (properties view 0))
(instance cursor3 of Prop (properties view 0))
(instance cursor4 of Prop (properties view 0))
(instance cursor5 of Prop (properties view 0))
(instance cursor6 of Prop (properties view 0))
(instance cursor7 of Prop (properties view 0))
(instance cursor8 of Prop (properties view 0))

(procedure public (PickView)
	
    (if	(>= --GC_rem 0)
        return(RandomViewByType(GC))
	)
	
	(if (>= --SF_rem 0)
		return(RandomViewByType(SF))
	)
	
	(if (>= --CV_rem 0)
		return(RandomViewByType(CV))
	)
	
	(if (>= --SK_rem 0)
		return(RandomViewByType(SK))
	)
	
	(if (>= --IP_rem 0)
		return(RandomViewByType(IP))
	)
	
	(if (>= --TR_rem 0)
		return(RandomViewByType(TR))
	)
	
	(if (>= --BU_rem 0)
		return(RandomViewByType(BU))
	)
	
	(if (>= --ST_rem 0)
		return(RandomViewByType(ST))
	)
	
	(if (>= --RK_rem 0)
		return(RandomViewByType(RK))
	)
	
	(if (>= --BD_rem 0)
		return(RandomViewByType(BD))
	)
)

(procedure public (RandomViewByType viewType)
	(var viewNum)
    	(do		
		    = v Random(1 maxViewDefined)
		) while (<> rType[v] viewType or == xBounded[v] X)  // loop until we get a view for our specified type AND it's not disabled (X)
		return(v)
)

(procedure public (SaveStudioScript fileExt)	
    (var hFile, fileName[15], buffer[100], ti, vi, ignoreActors)	
    
    Format(@fileName "R_STUDIO.%03d" fileExt) 
    Format(@scriptNum "%d" fileExt)
    
	(if (<> NULL (= hFile (FOpen(@fileName fCREATE))))
		
		// includes & use commands
		(for (= ti 0) (<= ti 9) (++ti) 
	    	GetFarText(0 ti @buffer)
	    	FPuts(hFile @buffer)
	    	FPuts(hFile "\n")			
		)
		
		// script # & rm instance
		FPuts(hFile "(script ")
        FPuts(hFile @scriptNum)
        FPuts(hFile ")\n\n(instance public rm")
        FPuts(hFile @scriptNum)
        FPuts(hFile " of Rm\n")
		
		(for (=ti 10) (<= ti 29) (++ti)
	    	GetFarText(0 ti @buffer)
	    	FPuts(hFile @buffer)
	    	FPuts(hFile "\n")				
		)
		
		// init views
		(for (=vi 0) (<= vi viewCount) (++vi)
	       = buffer NULL
	       (if (& (send vw[vi]:signal) $10)
	       	  = ignoreActors 1
		   )(else
		   	  = ignoreActors 0 
		   )
		   Format(@buffer "\t\t(send (View:new()):view(%d) x(%d) y(%d) cel(%d) ignoreActors(%d) setPri(%d) addToPic())\n" (send vw[vi]:view) (send vw[vi]:x) (send vw[vi]:y) (send vw[vi]:cel) ignoreActors (send vw[vi]:priority))
		   FPuts(hFile @buffer)		 
        )		
		
		
		(for (=ti 30) (<= ti 50) (++ti)
	    	GetFarText(0 ti @buffer)
	    	FPuts(hFile @buffer)
	    	FPuts(hFile "\n")				
		)		
	    FClose(hFile)  
	) 	
)

(procedure public (SaveSierraScript fileExt)	
    (var hFile, fileName[15], buffer[100], ti, vi, ignoreActors)	
   
    Format(@fileName "R_SIERRA.%03d" fileExt) 
    Format(@scriptNum "%d" fileExt)
    
	(if (<> NULL (= hFile (FOpen(@fileName fCREATE))))
		
		GetFarText(1 0 @buffer)
	   	FPuts(hFile @buffer)
	    FPuts(hFile "\n")
	    FPuts(hFile "(script# ")
	    FPuts(hFile @scriptNum)
	    FPuts(hFile ")\n")
	    			
		
		// includes & use commands
		(for (= ti 1) (<= ti 12) (++ti) 
	    	GetFarText(1 ti @buffer)
	    	FPuts(hFile @buffer)
	    	FPuts(hFile "\n")			
		)
		
		FPuts(hFile "\n(public rm")
	    FPuts(hFile @scriptNum)
	    FPuts(hFile " 0)\n\n(instance rm")
	    FPuts(hFile @scriptNum)
	    FPuts(hFile " of Rm\n")
	    
		
		(for (=ti 13) (<= ti 29) (++ti)
	    	GetFarText(1 ti @buffer)
	    	FPuts(hFile @buffer)
	    	FPuts(hFile "\n")				
		)
		
		// init views
		(for (=vi 0) (<= vi viewCount) (++vi)
	       = buffer NULL	
	       (if (& (send vw[vi]:signal) $10)
	       	  = ignoreActors 1
		   )(else
		   	  = ignoreActors 0 
		   )
		   Format(@buffer "\t\t((View new:) view:%d x:%d y:%d cel:%d ignoreActors:%d setPri:%d addToPic:)\n" (send vw[vi]:view) (send vw[vi]:x) (send vw[vi]:y) (send vw[vi]:cel) ignoreActors (send vw[vi]:priority))
		   FPuts(hFile @buffer)		 
        )		
		
		
		(for (=ti 30) (<= ti 49) (++ti)
	    	GetFarText(1 ti @buffer)
	    	FPuts(hFile @buffer)
	    	FPuts(hFile "\n")				
		)		
	    FClose(hFile)  
	) 	
)

(procedure (savePrompt bResult)
        // init the variable to the next script
        Format(@scriptNum "%d" gNextScriptNum)
        
        = bResult PrintMultiEdit("Save Room (to filesystem):\n  Script #:"
        	   #edit @scriptNum  4 20 1 12 1
               #button "  Cancel  " 0
        	   #button "  Skip  " 1
        	   #button "  Save  " 2
        	)
        
        // save
        (if (== bResult 2)
        	SaveSierraScript(ReadNumber(@scriptNum))
        	SaveStudioScript(ReadNumber(@scriptNum))
       	    = gNextScriptNum (+ 1 ReadNumber(@scriptNum))
		)

		// skip or save
		(if (<> bResult 0)
		 	(send gRoom:newRoom(INITROOMS_SCRIPT))
		)	
)